<template>
    <div>
        <q-avatar
            class="img-avatar"
            @click.stop="isPreview = true"
            v-if="url"
            :size="size"
        >
            <q-img :src="url" cover no-spinner>
                <template v-slot:error>
                    <q-avatar
                        color="grey-3"
                        :size="size"
                        :icon="`img:${fallbackUrl}`"
                    />
                </template>
            </q-img>
            <slot></slot>
        </q-avatar>
        <q-avatar
            v-else
            color="grey-3"
            :size="size"
            :icon="`img:${fallbackUrl}`"
        >
            <slot></slot>
        </q-avatar>
        <q-dialog
            class="no-shadow"
            :class="[$store.state.user.isDarkMode ? 'dark' : '']"
            v-model="isPreview"
        >
            <q-avatar @click.stop="isPreview = true" v-if="url" size="500px">
                <q-img :src="url" cover no-spinner>
                    <template v-slot:error>
                        <q-avatar
                            color="grey-3"
                            size="500px"
                            :icon="`img:${fallbackUrl}`"
                        />
                    </template>
                </q-img>
            </q-avatar>
            <q-avatar
                v-else
                color="grey-3"
                size="500px"
                :icon="`img:${fallbackUrl}`"
            />
        </q-dialog>
        <avatar-context-menu v-if="user" :user="user" />
    </div>
</template>

<style lang="scss" scoped>
.img-avatar {
    cursor: pointer;
    -webkit-transition: all 0.1s ease-in-out;
    -moz-transition: all 0.1s ease-in-out;
    transition: all 0.1s ease-in-out;

    &:hover {
        transform: scale(1.1);
    }
}
</style>

<script lang="ts">
import { defineComponent, ref } from 'vue';
import { User } from 'src/services/models/User';

export default defineComponent({
    name: 'Avatar',
    props: {
        url: {
            type: String,
            required: true
        },
        size: {
            type: String,
            required: true
        },
        fallbackUrl: {
            type: String,
            default: 'images/ic_user.svg'
        },
        user: {
            type: Object as () => User
        }
    },
    setup() {
        const isPreview = ref(false);

        return {
            isPreview
        };
    }
});
</script>
